"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
"""
import abc
import collections.abc
import google.protobuf.empty_pb2
import grpc
import grpc.aio
import ryax_execution.execution_v3_pb2
import typing

_T = typing.TypeVar('_T')

class _MaybeAsyncIterator(collections.abc.AsyncIterator[_T], collections.abc.Iterator[_T], metaclass=abc.ABCMeta):
    ...

class _ServicerContext(grpc.ServicerContext, grpc.aio.ServicerContext):  # type: ignore
    ...

class ActionExecutionStub:
    """Manage Ryax Action executions"""

    def __init__(self, channel: typing.Union[grpc.Channel, grpc.aio.Channel]) -> None: ...
    Init: grpc.UnaryUnaryMultiCallable[
        ryax_execution.execution_v3_pb2.InitRequest,
        ryax_execution.execution_v3_pb2.InitReply,
    ]
    """Initialize action before execution. Should be called only once."""
    Run: grpc.StreamStreamMultiCallable[
        ryax_execution.execution_v3_pb2.RunRequest,
        ryax_execution.execution_v3_pb2.RunReply,
    ]
    """Run a new execution
    Stream inputs one by one, or even chunk by chunk for inputs that may exceed 4MB
    Returns one (or more) execution results
    Each output is streamed one by one. Metadata is sent on the last message (last_reply_of_this_run==True)
    that does not contain any data.
    """
    Version: grpc.UnaryUnaryMultiCallable[
        google.protobuf.empty_pb2.Empty,
        ryax_execution.execution_v3_pb2.VersionReply,
    ]

class ActionExecutionAsyncStub:
    """Manage Ryax Action executions"""

    Init: grpc.aio.UnaryUnaryMultiCallable[
        ryax_execution.execution_v3_pb2.InitRequest,
        ryax_execution.execution_v3_pb2.InitReply,
    ]
    """Initialize action before execution. Should be called only once."""
    Run: grpc.aio.StreamStreamMultiCallable[
        ryax_execution.execution_v3_pb2.RunRequest,
        ryax_execution.execution_v3_pb2.RunReply,
    ]
    """Run a new execution
    Stream inputs one by one, or even chunk by chunk for inputs that may exceed 4MB
    Returns one (or more) execution results
    Each output is streamed one by one. Metadata is sent on the last message (last_reply_of_this_run==True)
    that does not contain any data.
    """
    Version: grpc.aio.UnaryUnaryMultiCallable[
        google.protobuf.empty_pb2.Empty,
        ryax_execution.execution_v3_pb2.VersionReply,
    ]

class ActionExecutionServicer(metaclass=abc.ABCMeta):
    """Manage Ryax Action executions"""

    @abc.abstractmethod
    def Init(
        self,
        request: ryax_execution.execution_v3_pb2.InitRequest,
        context: _ServicerContext,
    ) -> typing.Union[ryax_execution.execution_v3_pb2.InitReply, collections.abc.Awaitable[ryax_execution.execution_v3_pb2.InitReply]]:
        """Initialize action before execution. Should be called only once."""
    @abc.abstractmethod
    def Run(
        self,
        request_iterator: _MaybeAsyncIterator[ryax_execution.execution_v3_pb2.RunRequest],
        context: _ServicerContext,
    ) -> typing.Union[collections.abc.Iterator[ryax_execution.execution_v3_pb2.RunReply], collections.abc.AsyncIterator[ryax_execution.execution_v3_pb2.RunReply]]:
        """Run a new execution
        Stream inputs one by one, or even chunk by chunk for inputs that may exceed 4MB
        Returns one (or more) execution results
        Each output is streamed one by one. Metadata is sent on the last message (last_reply_of_this_run==True)
        that does not contain any data.
        """
    @abc.abstractmethod
    def Version(
        self,
        request: google.protobuf.empty_pb2.Empty,
        context: _ServicerContext,
    ) -> typing.Union[ryax_execution.execution_v3_pb2.VersionReply, collections.abc.Awaitable[ryax_execution.execution_v3_pb2.VersionReply]]: ...

def add_ActionExecutionServicer_to_server(servicer: ActionExecutionServicer, server: typing.Union[grpc.Server, grpc.aio.Server]) -> None: ...
